local FIX = CreateFrame("Frame");
FIX:SetScript("OnUpdate", function() IsDraggingCheck(); QuestUpdate(); end)

SimpleObjectivesMinimapButton:RegisterEvent("ADDON_LOADED")
SimpleObjectivesMinimapButton:RegisterEvent("QUEST_ACCEPTED")
SimpleObjectivesMinimapButton:RegisterEvent("QUEST_TURNED_IN")

SLASH_SOH1, SLASH_SOH2 = "/simpleobjectivehider", "/soh"

DEFAULT_TEX_COORDS = { 0, 0, 0, 0.5, 0.5, 0, 0.5, 0.5 }
CLICK_TEX_COORDS = { 0.5, 0, 0.5, 0.5, 1.0, 0, 1.0, 0.5 }

MouseOverride = false
ObjectiveVisibility = true
ObjectiveWQ = ""
CurrentQuest = 0
sohaddonLoaded = false

function QuestUpdate()
	_, _, worldQuestType, _, _, _, _ = GetQuestTagInfo(CurrentQuest)
	inArea,_, count, title = GetTaskInfo(CurrentQuest)

		if (worldQuestType ~= nil and inArea) then
				
				prog, obType, fin = GetQuestObjectiveInfo(CurrentQuest, count, false)
				ObjectiveWQ =  "\n\r|cffffffffWorld Quest : \n\r|cffff00f0" .. title .. "|cfff0ff00\n\r"  .. prog
			else
				ObjectiveWQ =  ""
		end
	
end
function SimpleObjectivesMinimapButton:QUEST_TURNED_IN(self, ...)
	local quest = ...
	if CurrentQuest == quest then
		CurrentQuest = 0
		ObjectiveWQ = ""
	end

end

function SimpleObjectivesMinimapButton:QUEST_ACCEPTED(self, ...)
	local quest = ...
	_, _, worldQuestType, _, _, _, _ = GetQuestTagInfo(quest)

	if (worldQuestType ~= nil) then
		CurrentQuest = quest
	end

end

function SimpleObjectivesMinimapButton:ADDON_LOADED(...)

	if SOData == nil or SOData.MapPosP == nil or SOData.ObjectiveVisible == nil or SOData.MapIcon == nil then
		MapPosP = {"CENTER", "UIParent", "CENTER", 0,0}
		SOData = { MapPosP = MapPosP , ObjectiveVisible = true, MapIcon = true }
	end
	MapPosP = SOData.MapPosP
	MapIcon = SOData.MapIcon
	ObjectiveVisibility = SOData.ObjectiveVisible
	ToggleObjectives(true)
	SetDefaultTexture()

	SimpleObjectivesMinimapButton:SetPoint(MapPosP[1],UIParent,MapPosP[3],MapPosP[4],MapPosP[5])
	sohaddonLoaded = true
	ToggleMapIcon(true)
	SlashCmdList["SOH"] = SOHSlashHandler
end

function SOHSlashHandler(msg, ...)
	local ret = ""
	if (msg == "") then
		DEFAULT_CHAT_FRAME:AddMessage("Simple Objectives Hider\n-----------\n|cfff0ff00/soh map - |cfffffffftoggles map icon\n|cff0f0ff0/soh toggle - |cfffffffftoggle objectives frame")
		ret = "yes"
	end

	if (msg =="toggle") then
		PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
		ToggleObjectives(false)
		ret = "yes"
	end

	if (msg =="map") then
		PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
		ToggleMapIcon(false)
		ret = "yes"
	end

	if (ret == "") then
		DEFAULT_CHAT_FRAME:AddMessage("Simple Objectives Hider\n-----------\n|cfff0ff00/soh map - |cfffffffftoggles map icon\n|cff0f0ff0/soh toggle - |cfffffffftoggle objectives frame")
	end
end

function ToggleMapIcon(init)		
	if (init == true) then
		if (MapIcon == true) then
			SimpleObjectivesMinimapButton:Show();
		else
			SimpleObjectivesMinimapButton:Hide();
		end
	else

		if (SimpleObjectivesMinimapButton:IsVisible()) then
			SOData.MapIcon = false;
			SimpleObjectivesMinimapButton:Hide();
		else
			SOData.MapIcon = true;
			SimpleObjectivesMinimapButton:Show();
		end
	end

end


function ToggleObjectives(startup)
	local objectFrame = ObjectiveTrackerFrame:IsShown()
	if startup == true then
		objectFrame = not ObjectiveVisibility
	end
	local chatMessage = ""
	
	if objectFrame then 
		chatMessage = "Objective Window: |cfff000f0Hidden"
		ObjectiveTrackerFrame:Hide() 
	else 
		chatMessage = "Objective Window: |cff00ff00Visible"
		ObjectiveTrackerFrame:Show() 
	end
	ObjectiveVisibility = ObjectiveTrackerFrame:IsShown()
	SOData.ObjectiveVisible = ObjectiveVisibility
	return chatMessage
end
function SimpleObjectivesMinimapButton_OnClick()
	PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
	RaidNotice_AddMessage(RaidWarningFrame, ToggleObjectives(false), ChatTypeInfo["RAID_WARNING"])
end
function SimpleObjectivesMinimapButton_OnMouseDown()
	MouseOverride = true;
	SetClickTexture()
end
function SimpleObjectivesMinimapButton_OnMouseUp()
	MouseOverride = false;
	SetDefaultTexture()
end
function SimpleObjectivesMinimapButton_OnLeave()
	MouseOverride = false;
	GameTooltip:Hide()
end

function SimpleObjectivesMinimapButton_OnEnter()
	GameTooltip:SetOwner(SimpleObjectivesMinimapButton_Icon, "ANCHOR_BOTTOMLEFT",0, 30)
	GameTooltip:SetText("|cffffffffSimple Objectives Hider")
	GameTooltip:AddLine("|cff666666Left Click - |cff00ff00Toggle Objectives")
	GameTooltip:AddLine("|cff666666Right Click - |cff00ff00Move This")

	local inst, instType = IsInInstance()
	if (not ObjectiveTrackerFrame:IsShown()) then
		if (inst and (instType == "party" or instType == nil)) then
			GameTooltip:AddLine("\n\r|cffffffffDungeon Objectives : ")
			for k,v in pairs(ScenarioObjectiveBlock.lines) do
				
					GameTooltip:AddLine(v.Text:GetText())
				
			end
		end
		
		GameTooltip:AddLine(ObjectiveWQ)
	end


	GameTooltip:Show()
end

function SetDefaultTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(DEFAULT_TEX_COORDS[1],DEFAULT_TEX_COORDS[2],DEFAULT_TEX_COORDS[3],DEFAULT_TEX_COORDS[4],DEFAULT_TEX_COORDS[5],DEFAULT_TEX_COORDS[6],DEFAULT_TEX_COORDS[7],DEFAULT_TEX_COORDS[8])
end

function SetClickTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(CLICK_TEX_COORDS[1],CLICK_TEX_COORDS[2],CLICK_TEX_COORDS[3],CLICK_TEX_COORDS[4],CLICK_TEX_COORDS[5],CLICK_TEX_COORDS[6],CLICK_TEX_COORDS[7],CLICK_TEX_COORDS[8])
end

function IsDraggingCheck()
	if MouseOverride == true then
		SetClickTexture()
	elseif SimpleObjectivesMinimapButton_DraggingFrame:IsVisible() == false then
		SetDefaultTexture()
	else
		SetClickTexture()
	end
end


function SimpleObjectivesMinimapButton_DraggingFrame_OnUpdate()
	if (sohaddonLoaded == true) then
		MapPosPTemp = {SimpleObjectivesMinimapButton:GetPoint()}
		MapPosP = {MapPosPTemp[1],UIParent,MapPosPTemp[3],MapPosPTemp[4],MapPosPTemp[5]}
		
		SOData = {  MapPosP = MapPosP, ObjectiveVisible = ObjectiveVisibility, MapIcon = MapIcon }
	end

end

